# Ogre::StaticGeometry::MaterialBucket Class Reference

A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly the same LOD). More...

`#include <OgreStaticGeometry.h>`

List of all members.

## Public Types

typedef std::vector< GeometryBucket * > | GeometryBucketList
| list of Geometry Buckets in this region
typedef VectorIterator< GeometryBucketList > | GeometryIterator
| Iterator over geometry.

## Public Member Functions

| MaterialBucket (LODBucket *parent, const String &materialName)
virtual | ~MaterialBucket ()
LODBucket * | getParent (void)
const String & | getMaterialName (void) const
| Get the material name.
void | assign (QueuedGeometry *qsm)
| Assign geometry to this bucket.
void | build (bool stencilShadows)
| Build.
void | addRenderables (RenderQueue *queue, RenderQueueGroupID group, Real camSquaredDist)
| Add children to the render queue.
const MaterialPtr & | getMaterial (void) const
| Get the material for this bucket.
GeometryIterator | getGeometryIterator (void)
| Get an iterator over the contained geometry.
Technique * | getCurrentTechnique (void) const
| Get the current Technique.
void | dump (std::ofstream &of) const
| Dump contents for diagnostics.

## Protected Types

typedef std::map< String, GeometryBucket * > | CurrentGeometryMap

## Protected Member Functions

String | getGeometryFormatString (SubMeshLodGeometryLink *geom)
| Get a packed string identifying the geometry format.

## Protected Attributes

LODBucket * | mParent
| Pointer to parent LODBucket.
String | mMaterialName
| Material being used.
MaterialPtr | mMaterial
| Pointer to material being used.
Technique * | mTechnique
| Active technique.
GeometryBucketList | mGeometryBucketList
| list of Geometry Buckets in this region
CurrentGeometryMap | mCurrentGeometryMap

## Detailed Description

A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly the same LOD).

Definition at line 243 of file OgreStaticGeometry.h.

## Member Typedef Documentation

typedef std::map<String, GeometryBucket*> Ogre::StaticGeometry::MaterialBucket::CurrentGeometryMap `[protected]`

| Definition at line 261 of file OgreStaticGeometry.h.

typedef std::vector<GeometryBucket*> Ogre::StaticGeometry::MaterialBucket::GeometryBucketList

| list of Geometry Buckets in this region Definition at line 247 of file OgreStaticGeometry.h.

typedef VectorIterator<GeometryBucketList> Ogre::StaticGeometry::MaterialBucket::GeometryIterator

| Iterator over geometry. Definition at line 282 of file OgreStaticGeometry.h.

## Constructor & Destructor Documentation

Ogre::StaticGeometry::MaterialBucket::MaterialBucket | ( | LODBucket * | parent,
|  | const String & | materialName
| ) |

virtual Ogre::StaticGeometry::MaterialBucket::~MaterialBucket | ( |  | ) | `[virtual]`

## Member Function Documentation

void Ogre::StaticGeometry::MaterialBucket::addRenderables | ( | RenderQueue * | queue,
|  | RenderQueueGroupID | group,
|  | Real | camSquaredDist
| ) |

| Add children to the render queue.

void Ogre::StaticGeometry::MaterialBucket::assign | ( | QueuedGeometry * | qsm | ) |

| Assign geometry to this bucket.

void Ogre::StaticGeometry::MaterialBucket::build | ( | bool | stencilShadows | ) |

| Build.

void Ogre::StaticGeometry::MaterialBucket::dump | ( | std::ofstream & | of | ) | const

| Dump contents for diagnostics.

Technique* Ogre::StaticGeometry::MaterialBucket::getCurrentTechnique | ( | void |  | ) | const

| Get the current Technique. Definition at line 286 of file OgreStaticGeometry.h.

String Ogre::StaticGeometry::MaterialBucket::getGeometryFormatString | ( | SubMeshLodGeometryLink * | geom | ) | `[protected]`

| Get a packed string identifying the geometry format.

GeometryIterator Ogre::StaticGeometry::MaterialBucket::getGeometryIterator | ( | void |  | ) |

| Get an iterator over the contained geometry.

const MaterialPtr& Ogre::StaticGeometry::MaterialBucket::getMaterial | ( | void |  | ) | const

| Get the material for this bucket. Definition at line 280 of file OgreStaticGeometry.h.

const String& Ogre::StaticGeometry::MaterialBucket::getMaterialName | ( | void |  | ) | const

| Get the material name. Definition at line 271 of file OgreStaticGeometry.h. References Ogre::String.

LODBucket* Ogre::StaticGeometry::MaterialBucket::getParent | ( | void |  | ) |

| Definition at line 269 of file OgreStaticGeometry.h.

## Member Data Documentation

CurrentGeometryMap Ogre::StaticGeometry::MaterialBucket::mCurrentGeometryMap `[protected]`

| Definition at line 262 of file OgreStaticGeometry.h.

GeometryBucketList Ogre::StaticGeometry::MaterialBucket::mGeometryBucketList `[protected]`

| list of Geometry Buckets in this region Definition at line 259 of file OgreStaticGeometry.h.

MaterialPtr Ogre::StaticGeometry::MaterialBucket::mMaterial `[protected]`

| Pointer to material being used. Definition at line 254 of file OgreStaticGeometry.h.

String Ogre::StaticGeometry::MaterialBucket::mMaterialName `[protected]`

| Material being used. Definition at line 252 of file OgreStaticGeometry.h.

LODBucket* Ogre::StaticGeometry::MaterialBucket::mParent `[protected]`

| Pointer to parent LODBucket. Definition at line 250 of file OgreStaticGeometry.h.

Technique* Ogre::StaticGeometry::MaterialBucket::mTechnique `[protected]`

| Active technique. Definition at line 256 of file OgreStaticGeometry.h.

The documentation for this class was generated from the following file:

- OgreStaticGeometry.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:40:26 2005